function TFGraphInit(container_id, canvas_id) {
    $('#'+container_id).append('<div id="'+canvas_id+'" style="width: 500px; height: 500px;">');
    //$('#'+container_id).append('<div>Mic Ch.<input id="switch_mic" type="number" />　　Src No.<input id="switch_src" type="number" /></div>');
}

function makeDashedArray(rows, key) {

    var newRows = [];

    for(var i = 0 ; i < (rows.length - 1) ; i++) {
        newRows.push(rows[i]);
        if(rows[i][key] >= rows[i+1][key]) {
            newRows.push(new Object({id: "", mic: undefined, x: undefined, y: undefined, z: undefined}));
        }
    }

    return newRows;
}

// global variable (TODO: to local)
var wholeDataSet;

function _TFGraphDraw(canvas_id, doUpdate) {
    var target = $('#currentTarget').val() || "mic";
    var targetIndex = Number((target === "mic")?$('#switch_mic').val():$('#switch_src').val()) || 0;
    var zaxis = $('#zAxis').val() || "amp";
    var disp = $('#disp').val() || "TF";
    var dataSet;
    if (target === "mic") {
        dataSet = _.filter(wholeDataSet, function(r){ return r.mic === targetIndex; });
    } else { // target === "src"
        dataSet = _.filter(wholeDataSet, function(r){ return r.id === targetIndex; });
    }

    console.log("dataSet=", dataSet);
    // sort
    dataSet = _.sortBy(dataSet, 'x');
    if (target === "mic") {
        dataSet = _.sortBy(dataSet, 'id');
    } else { // target === "src"
        dataSet = _.sortBy(dataSet, 'mic');
    }
    dataSet = makeDashedArray(dataSet, 'x');
    var titles = (target === "mic")?["Mic","Ch"]:["Src","No"];
    var xlabel = (disp === "TF")?"Hz":"msec";
    var ylabels = (target !== "mic")?["Mic","Ch"]:["Src","No"];
    var zlabel = (zaxis === "amp")?"Amp":(zaxis === "db")?"dB":(zaxis === "phase")?"Phase":"Amp";
    var layout = {
        showlegend: false,
        title: "Transfer Function of " + titles[0] + " " + titles[1] + ". " + targetIndex,
        scene: {
            xaxis: {
                title: "[" + xlabel + "]"
            },
            yaxis: {
                title: ylabels[0] + "[" + ylabels[1] + "]"
            },
            zaxis: {
                title: "[" + zlabel + "]"
            },
            camera: {
                eye: { x: 1.2, y: -1.2, z: 1.2 },
            }
        },
        margin: { l: 0, r: 0, b: 0, t: 80 }
    };

    var _x = _.map(dataSet, function(r) {return r.x;});
    var _y = _.map(dataSet, function(r) {return (target === "mic")?r.id:r.mic;});
    var _z = _.map(dataSet, function(r) {return r.z;});

    var data = [{
            type: 'scatter3d',
            mode: 'lines',
            x: _x,
            y: _y,
            z: _z,
            opacity: 1,
            line: {
                width: 2,
                color: "#007acc"
            }
        }];
    if (doUpdate) {
        // document.getElementById(canvas_id).on('plotly_click', function(eventData) {
        // 	console.log("********plotly_click********");
        // });
        Plotly.purge(canvas_id);
        Plotly.newPlot(canvas_id, data, layout);
    } else {
        Plotly.newPlot(canvas_id, data, layout);
    }

    document.getElementById(canvas_id).on('plotly_click', function(eventData) {
        console.log("clicked line=", eventData.points[0].y);
        if ($('#currentTarget').val() === "mic") {
            $('#switch_src').val(eventData.points[0].y);
        } else {
            $('#switch_mic').val(eventData.points[0].y);
        }
    });
}

function TFGraphDraw(canvas_id, filename, zaxis, disp, callback) {
    console.log("filename=", filename);
    console.log("zaxis=", zaxis);

    Plotly.d3.csv(filename, function(error, rows) {

        wholeDataSet = _.map(rows, function(r){ return {id:Number(r.id), mic:Number(r.mic), x:Number(r.x), z:Number(r.z)}; });

        var minSrc = _.min(wholeDataSet, function(data){ return data.id; }).id;
        var minMic = _.min(wholeDataSet, function(data){ return data.mic; }).mic;
        $('#currentTarget').val("mic");
        $('#zAxis').val(zaxis);
        $('#disp').val(disp);
        $('#switch_src').val(minSrc);
        $('#switch_mic').val(minMic);
        $('#switchform').show();
        _TFGraphDraw(canvas_id, false);

        if(callback) callback();
    });

}
